-- Turret Defense Map 1 V1.0
-- Made by Chirmaya
-- A lot of thanks to Saya's SUPREME ART OF DEFENCE V 1.1 ALPHA for great coding that was easy to reference (and use a lot of =D)
-- Also a lot of thanks to the whole Supreme Commander community for everything from help to inspiration.

local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')
local ScenarioTriggers = import('/lua/scenariotriggers.lua')

local waveNumber = 1
local lives = 40

local waves = {
	{waveLength = 10, unit = 'url0101', number = 20, mass = 1},
	{waveLength = 10, unit = 'uel0106', number = 20, mass = 1},
	{waveLength = 10, unit = 'url0106', number = 20, mass = 1},
	{waveLength = 10, unit = 'uel0201', number = 20, mass = 1},
	{waveLength = 10, unit = 'url0107', number = 20, mass = 1},
	{waveLength = 10, unit = 'url0202', number = 20, mass = 1},
}
   
function OnPopulate()
	-- Sets the map boundaries so that you don't see some wackey stuff on the edges
	#import('/lua/ScenarioFramework.lua').SetPlayableArea('areaMapBoundary', false)
	-- Stops the commanders from spawning (and other things like resources setting up and view changing)
	#ScenarioUtils.InitializeArmies()
	InitializeAlliances()
end
   
function OnStart(self)
	InitializeEngineers()
	InitializeTriggers()
	InitializeWaves()
end


-- Custom functions start here


-- Sets the alliances of all teams
function InitializeAlliances()
	local tblArmy = ListArmies()
	--determine the players depending on which slots are occupied
	for index,army in tblArmy do
		GetArmyBrain(army):SetResourceSharing(false)
		for index2,army2 in tblArmy do
			if army != army2 then
				if army == 'ARMY_12' then
					SetAlliance(army, army2, 'Enemy')
				elseif army2 == 'ARMY_12' then
					SetAlliance(army, army2, 'Enemy')
				else
					SetAlliance(army, army2, 'Ally')
				end
			end
		end
	end
end

-- Spawns the starting Engineers for all teams
function InitializeEngineers()
	local tblArmy = ListArmies()
	local x, y
	
	--determine the players depending on which slots are occupied
	for index,army in tblArmy do
		if army == 'ARMY_1' then
			x = 128
			y = 220
		end
		if army == 'ARMY_2' then
			x = 128
			y = 50
		end
		if army == 'ARMY_3' then
			x = 50
			y = 110
		end
		if army == 'ARMY_4' then
			x = 206
			y = 110
		end
		if army == 'ARMY_5' then
			x = 10
			y = 50
		end
		if army == 'ARMY_6' then
			x = 246
			y = 50
		end
		if army != 'ARMY_12' then
			engineer = CreateInitialArmyUnit(army, 'ch_et01')
			#local engineer2 = CreateUnitHPR('ch_et01', army, x, 64, y, 0, 0, 0)
			engineer:SetDoNotTarget(true)
			engineer:SetCanBeKilled(false)
			engineer:SetCapturable(false)
			engineer:SetReclaimable(false)
			engineer:SetDoNotTarget(true)
		end
	end
end

-- These triggers will make things happen when units of a certain category and team walk into them
function InitializeTriggers()
	--CreateAreaTrigger(callbackFunction, rectangle, category, onceOnly, invert, aiBrain, number, requireBuilt)
	-- Gets a list of all entities within a defined rectangle.
	--  callbackFunction = the entities that match the category will be placed into the function
	--  rectangle = a map area or rectangle
	--  category = Like EDF or LAND or MOBILE and such. Listed in a unit's bp. Make sure you have categories.WHATEVER
	--  onceOnly = will not run again after it runs for the first time
	--  invert = runs when units are NOT in the area
	--  aiBrain = the brain of whatever army. Has to match the units it is testing for
	--  number = false makes it kick out as soon as one of the entities is in there, returning that entity to the callbackFunction.  Else it builds them into a table of entities and sends them to the callbackFunction
	--  requireBuilt = requires the unit being tested to be fully constructed before being accepted as the correct entity
	local TriggerEscape = ScenarioTriggers.CreateAreaTrigger(EnemyScoredWithThisEntity, 'areaEscape', categories.MOBILE, false, false, GetArmyBrain('ARMY_12'), false, true)
	local tblArmy = ListArmies()
	for index,army in tblArmy do
		if army != 'ARMY_12' then
			local TriggerNoBuild1 = ScenarioTriggers.CreateAreaTrigger(NoBuild, 'areaNoBuild1', categories.STRUCTURE, false, false, GetArmyBrain(army), false, false)
			local TriggerNoBuild2 = ScenarioTriggers.CreateAreaTrigger(NoBuild, 'areaNoBuild2', categories.STRUCTURE, false, false, GetArmyBrain(army), false, false)
			local TriggerNoBuild3 = ScenarioTriggers.CreateAreaTrigger(NoBuild, 'areaNoBuild3', categories.STRUCTURE, false, false, GetArmyBrain(army), false, false)
			local TriggerNoBuild4 = ScenarioTriggers.CreateAreaTrigger(NoBuild, 'areaNoBuild4', categories.STRUCTURE, false, false, GetArmyBrain(army), false, false)
			local TriggerNoBuild5 = ScenarioTriggers.CreateAreaTrigger(NoBuild, 'areaNoBuild5', categories.STRUCTURE, false, false, GetArmyBrain(army), false, false)
			local TriggerNoBuild6 = ScenarioTriggers.CreateAreaTrigger(NoBuild, 'areaNoBuild6', categories.STRUCTURE, false, false, GetArmyBrain(army), false, false)
			local TriggerNoBuild7 = ScenarioTriggers.CreateAreaTrigger(NoBuild, 'areaNoBuild7', categories.STRUCTURE, false, false, GetArmyBrain(army), false, false)
			local TriggerNoBuild8 = ScenarioTriggers.CreateAreaTrigger(NoBuild, 'areaNoBuild8', categories.STRUCTURE, false, false, GetArmyBrain(army), false, false)
			local TriggerNoBuild9 = ScenarioTriggers.CreateAreaTrigger(NoBuild, 'areaNoBuild9', categories.STRUCTURE, false, false, GetArmyBrain(army), false, false)
			local TriggerNoBuild10 = ScenarioTriggers.CreateAreaTrigger(NoBuild, 'areaNoBuild10', categories.STRUCTURE, false, false, GetArmyBrain(army), false, false)
			local TriggerNoBuild11 = ScenarioTriggers.CreateAreaTrigger(NoBuild, 'areaNoBuild11', categories.STRUCTURE, false, false, GetArmyBrain(army), false, false)
			local TriggerNoBuild12 = ScenarioTriggers.CreateAreaTrigger(NoBuild, 'areaNoBuild12', categories.STRUCTURE, false, false, GetArmyBrain(army), false, false)
			local TriggerNoBuild13 = ScenarioTriggers.CreateAreaTrigger(NoBuild, 'areaNoBuild13', categories.STRUCTURE, false, false, GetArmyBrain(army), false, false)
			local TriggerNoBuild14 = ScenarioTriggers.CreateAreaTrigger(NoBuild, 'areaNoBuild14', categories.STRUCTURE, false, false, GetArmyBrain(army), false, false)
			local TriggerNoBuild15 = ScenarioTriggers.CreateAreaTrigger(NoBuild, 'areaNoBuild15', categories.STRUCTURE, false, false, GetArmyBrain(army), false, false)
		end
	end
	
end

function EnemyScoredWithThisEntity(triggeringEntity)
	triggeringEntity:Destroy()
	lives = lives - 1
	if lives == 0 then
		PrintText('You have been defeated',20,nil,5,'center')
		WaitSeconds(4)	
		local tblArmy = ListArmies()
		for index,army in tblArmy do
			if army != 'ARMY_12' then
				GetArmyBrain(army):OnDefeat()
			end
		end
	elseif lives == 1 then
		PrintText('You now have 1 life left',20,nil,5,'center')
	elseif lives > 1 then
		PrintText('You now have ' .. lives .. ' lives left',20,nil,5,'center')
	end
end

function NoBuild(triggeringEntity)
	triggeringEntity:Destroy()
	PrintText('Do not build there',20,nil,5,'center')
end

function InitializeWaves()
	-- Spawns the waves at the correct times. Ends when all of the waves have been created.
	local WaveThread = ForkThread (function(self)
		-- Delay before the first wave appears
		WaitSeconds(30)
		PrintText('The enemy will arrive in 30 seconds.',20,nil,5,'center')
		PrintText('You have 40 lives.',20,nil,5,'center')
		while waveNumber <= table.getn(waves) do
			-- Spawn enemy wave now
			PrintText('Wave ' .. waveNumber .. ' approaches',20,nil,5,'center')
			SpawnWave()
			-- Wait for the specified time in between waves
			WaitSeconds(WavesReturn().waveLength)
			waveNumber = waveNumber + 1
		end
		PrintText('There are no waves left',20,nil,5,'center')
	end)
end

function SpawnWave ()
	local tblArmy = ListArmies()

	for index,army in tblArmy do
		if army != 'ARMY_12' then
			local armyNumber = string.gsub(army, 'ARMY_', '')
			local areaName = ScenarioUtils.AreaToRect('areaSpawn' .. armyNumber)
			local unitCounter = 1
			local x = areaName.x0
			local y = areaName.y0
			local unitGroup = {}
			local unitMax = WavesReturn().number
			
			-- army1 is the last defender. They get half the unit amount to be safe. 
			-- army2 has 2x the units, but only army1 to fall back on
			-- army5 and army6 have 2x the units with army3 and army4 to fall back on, and then army1
			if armyNumber == '1' then
				unitMax = unitMax / 2
			elseif armyNumber == '2' or armyNumber == '5' or armyNumber == '6' then
				unitMax = unitMax * 2
			end
			
			while unitCounter <=  unitMax do
				local unit = CreateUnitHPR(WavesReturn().unit, 'ARMY_12', x, 64, y, 0, 0, 0)
				
				-- Gives them a function which will give the kill the mass amount
				AttachMassOnKilled(unit, WavesReturn().mass)
				
				table.insert(unitGroup,unit)
				x = x + 3
				
				if x > areaName.x1 then
					x = areaName.x0
					y = y + 3
				end
				unitCounter = unitCounter + 1
			end
			
			-- Makes the enemies move to queued points
			local brainArmy12 = GetArmyBrain('ARMY_12')
			local unitPlatoon = brainArmy12:MakePlatoon('','')
			brainArmy12:AssignUnitsToPlatoon(unitPlatoon, unitGroup, 'Attack', 'GrowthFormation')
			
			if not(armyNumber == '1' or armyNumber == '2') then
				if armyNumber == '5' then
					-- move to the center-left of the map
					unitPlatoon:MoveToLocation({10,64,133}, false)
				elseif armyNumber == '6' then
					-- move to the center-right of the map
					unitPlatoon:MoveToLocation({246,64,133}, false)
				end
				-- move to center of the map
				unitPlatoon:MoveToLocation({128,64,133}, false)
			end
			-- move to the center-bottom of the map
			unitPlatoon:MoveToLocation({128,64,255}, false)
		end
	end
end

-- Allows the 'waves' info to be looked up and returned for waveLength, units, and number
function WavesReturn()
	return waves[waveNumber]
end

function AttachMassOnKilled(unit, mass)
	unit.OldOnKilled = unit.OnKilled
	unit.OnKilled = function(self, instigator, type, overkillRatio)
		unit.OldOnKilled(self, instigator, type, overkillRatio)
			if instigator then
				local brainArmy = GetArmyBrain(instigator.GetArmy(instigator))
				brainArmy:GiveResource('Mass', mass)
			end
	end
end